#include "stdafx.h"
#include "seznam.h"


char *allocVal(char *src)
{
  char *cp = (char *)malloc(strlen(src) + 1);
  if (cp)
    strcpy(cp, src);

  return cp;
}

void listShow(listDescr *list)
{
  int n=0;
  item *temp;
  temp=list->first;
  if (temp == NULL)
    puts("List Empty");
  else
  {
    printf("\nFirst: %08X\n", temp);    // show address of first
    for(; temp; temp = temp->next)
       {
        n++;
		printf("%3d %s %s %s %s %s %s %s %s\n", n,
		  temp->first_name,
		  temp->last_name,
		  temp->company_name,
		  temp->address,
		  temp->city,
		  temp->county,
		  temp->state,
		  temp->zip);
		if (!(n%20)) getch(); 
       } 
  }
}


bool freeItem(item *x)
{
 char *cp;
 int i;
 if (x==NULL) return false;
 for (i=0;i<POC_SL;i++)
   {
    cp=((ppchar)x)[i];
    if (cp) free(cp);
   }
 free(x);
 return true;
}

bool listClear(listDescr *list)
{
  if (list->first == NULL)
    return false;

  while(list->first)
  {
    item *temp = list->first->next;
    freeItem(list->first);
    list->first=temp;
  }
  return true;
}



bool listAdd(listDescr *list, char *txt)
{
  item *temp, *newItem;;
  
  newItem=createItem(txt);
  if (newItem==NULL)
	return false;
	 		
  if((temp = list->first)!=NULL)
	for(; temp->next; temp = temp->next)
		;
  if (temp==NULL)
	list->first=newItem;
  else
    { 
     temp->next=newItem;
    } 		 	  

  return true;
}

item *createItem(char *txt)
{
 item *x;
 char *cp;
 int i;
 x=(item *)malloc(sizeof(item));
 if (x==NULL) return x;
 memset(x, 0, sizeof(item));
 cp=strtok(txt, seps);
 for (i=0;i<POC_SL;i++)
	{
	 if (!cp) break;
	 ((ppchar)x)[i]=allocVal(cp);
	 cp=strtok(NULL, seps);
	}
 return x;
} 	